import java.util.Vector;
/**
 * Root container
 */
public abstract class Namespace extends ObservedModelElement implements VisitedElement {
  private Vector observedModelElementCollection= new Vector();
  /**
   * Concrete visitor accept implementation
   */
  public void acceptModelVisitor(ModelVisitor aModelVisitor) {
    aModelVisitor.visitNamespace(this);
  }
  /**
   * Removes an element from the collection of properties
   */
  public void removeElement(ObservedModelElement anElement) {
    observedModelElementCollection.removeElement(anElement);
  }
  /**
   * Gets the collection of properties
   */
  public Vector getElements() {
    return observedModelElementCollection;
  }
  /**
   * Adds an element to the collection of properties
   */
  public void addElement(ObservedModelElement anElement) {
    observedModelElementCollection.addElement(anElement);
  }
}