import java.beans.PropertyChangeSupport;
import java.beans.PropertyChangeListener;
/**
 * Introduces observed subject functionality.
 */
public abstract class ObservedElement {
  private PropertyChangeSupport listeners= new PropertyChangeSupport(this);
  /**
   * Fires a PropertyChange notification to all listeners
   */
  public void firePropertyChange(String propertyName, Object oldValue, Object newValue) {
    listeners.firePropertyChange(propertyName, oldValue, newValue);
  }
  /**
   * Adds a PropertyChangeListener to be notified
   */
  public void addPropertyChangeListener(PropertyChangeListener aListener) {
    listeners.addPropertyChangeListener(aListener);
  }
  /**
   * Removes a PropertyChangeListener
   */
  public void removePropertyChangeListener(PropertyChangeListener aListener) {
    listeners.removePropertyChangeListener(aListener);
  }
}