import java.util.Vector;
import java.util.Enumeration;
/**
 * Basic email functionality.
 */
public abstract class Email {
  private boolean approved;
  private boolean delivered;
  private String receiver;
  private String originator;
  private String content;
  private String route;
  private Vector observerEmailCollection= new Vector();
  /**
   * Removes an element from the collection of properties
   */
  public void deleteObserverEmail(ObserverEmail aObserverEmail) {
    observerEmailCollection.removeElement(aObserverEmail);
  }
  /**
   * Gets the collection of properties
   */
  public Vector getObserversEmail() {
    return observerEmailCollection;
  }
  /**
   * Adds an element to the collection of properties
   */
  public void addObserver(ObserverEmail aObserverEmail) {
    observerEmailCollection.addElement(aObserverEmail);
  }
  /**
   * Sets the property value
   */
  public void setRoute(String route) {
    this.route = route;
  }
  /**
   * Gets the property value
   */
  public String getRoute() {
    return this.route;
  }
  /**
   * Gets the property value
   */
  public String getContent() {
    return this.content;
  }
  /**
   * Sets the property value
   */
  public void setContent(String content) {
    this.content = content;
  }
  /**
   * Notifies attached observers of a change by invoking update.
   */
  public void notifyObserversEmail() {
    ObserverEmail observer;
    Enumeration obs = getObserversEmail().elements();
    while (obs.hasMoreElements()) {
      observer = (ObserverEmail) obs.nextElement();
      observer.update(this);
    }
  }
  /**
   * Gets the property value
   */
  public String getOriginator() {
    return this.originator;
  }
  /**
   * Sets the property value
   */
  public void setOriginator(String originator) {
    this.originator = originator;
  }
  /**
   * Gets the property value
   */
  public String getReceiver() {
    return this.receiver;
  }
  /**
   * Sets the property value
   */
  public void setReceiver(String receiver) {
    this.receiver = receiver;
  }
  /**
   * Approves email message.
   */
  public void approve() {
    approved = true;
    System.out.println("Message approved");
  }
  /**
   * Sends as a reply to the email message.
   */
  public void reply() {
    System.out.println("Message replied");
  }
  /**
   * Delivers the email message according to the route.
   */
  public void deliver() {
    delivered = true;
    System.out.println("Message delivered");
  }
  /**
   * True when the email message has been approved.
   */
  public boolean isApproved() {
    return approved;
  }
  /**
   * Sends the email message.
   */
  public void send() {
    System.out.println("Message sent");
  }
  /**
   * True when email message has been delivered.
   */
  public boolean isDelivered() {
    return delivered;
  }
}